<template>
    <v-container>
        <v-row>
            <v-col cols="12" sm="5" offset="1">
                <div class="title">Fiche client
                    <v-icon id="icon" medium light right class="" v-on:click="editClient">save</v-icon>
                </div>
                <row_fiche_client v-model="client.name" label="Nom"/>
                <row_fiche_client v-model="client.title" label="Titre"/>
                <row_fiche_client v-model="client.address" label="Adresse"/>
                <row_fiche_client v-model="client.city" label="Ville"/>
                <row_fiche_client v-model="client.postalCode" label="Code Postal"/>
                <row_fiche_client v-model="client.phone" label="Téléphone"/>
                <row_fiche_client v-model="client.phone2" label="Téléphone 2"/>
                <row_fiche_client v-model="client.email" label="Email"/>
            </v-col>
            <v-col cols="12" sm="5">
                <div class="title">Liste des devis</div>
                <div id="div-list-devis">
                    <v-card v-for="devis in devisArray" :key="devis.id" hover class="card-devis"
                            @click="detailDevis(devis.id)">
                        <v-card-text>
                            Devis {{devis.numDevis}}
                        </v-card-text>
                    </v-card>
                </div>
                <v-btn id="btn-create-devis" @click="detailDevis()"> Créer un devis</v-btn>
            </v-col>
            <v-snackbar v-model="snackbar" color="green" :timeout="1000">{{snackbarText}}</v-snackbar>
        </v-row>
    </v-container>
</template>

<script>
    import axios from 'axios'
    import row_fiche_client from "../components/row_fiche_client";
    import {mapActions} from "vuex";

    export default {
        name: "ClientDetail",
        components: {row_fiche_client},
        data: () => ({
            snackbar: false,
            snackbarText: "",
        }),
        computed: {
            client() {
                return this.$store.state.client;
            },
            devisArray() {
                return this.$store.state.client.devis;
            }
        },
        beforeMount() {
            this.getClient();
        },
        methods: {
            ...mapActions(['getClient']),
            detailDevis(id) {
                this.$router.push({name: 'DetailDevis', params: {id: id}})
            },
            editClient() {
                this.snackbarText = (this.client.id) ? "Client mis à jour" : "Client créé";
                axios.post("/saveClient", JSON.stringify(this.client, replacer), {}).then((res) => {
                        this.snackbar = true;
                        this.$route.params.id = res.data.id;
                        this.$store.commit("selectClient", res.data.id);
                        this.getClient();
                    }
                );
            }
        }
    }

    function replacer(key, value) {
        if (key == "devis") return undefined;
        else return value;
    }

</script>

<style scoped>
    .title {
        background: green;
        color: white;
        border-radius: 5px;
        text-align: center;
        font-weight: bold;
        height: 42px;
    }

    #icon {
        color: white;
    }

    #div-list-devis {
        text-align: -webkit-center;
    }

    .card-devis {
        width: 50%;
        padding: 0 !important;
        margin-top: 8px;
        font-weight: bold !important;
    }

    #btn-create-devis {
        margin-top: 8px;
        background-color: darkgreen;
        color: white;
    }
</style>